#ifndef __SOLARISIOCTLSAS_H__
#define __SOLARISIOCTLSAS_H__


#include <iostream>
#include <pthread.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <sys/systeminfo.h>
#include <fcntl.h>          /* File control definitions */
#include <errno.h>          /* Error number definitions */
#include <unistd.h>         /* fork() */
#include <netinet/in.h>
#include <netdb.h>
#include <stdarg.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <ftw.h>

#include <sys/mhd.h>
#include <sys/scsi/impl/uscsi.h>
#include <sys/scsi/generic/commands.h>
#include <sys/scsi/generic/inquiry.h>


#include "commdef.h"
#include "if.h"

class SolarisIoctlSASInterface : public ArcInterface
{
public:
	SolarisIoctlSASInterface();
	~SolarisIoctlSASInterface();
	bool init(const int nScsiPort);
	int send(sIF_CMD_BLOCK *ifData);
	int recv(sIF_CMD_BLOCK *ifData);	
	int syncSend(sIF_CMD_BLOCK *ifData);
	void requirelock();
  void releaselock();
  void *getDeviceHandle();
	BOOL ClearReadBuffer();
	BOOL ClearWriteBuffer();
	BOOL ClearReadWriteBuffer();
	int	getMTU();	
private:
	HANDLE	m_hScsi;
	int fd;
  pthread_mutex_t mut;
};

#endif
